import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test_bhargav/utils/common_utils.dart';
import 'package:flutter_test_bhargav/utils/string_utils.dart';
import 'package:flutter_test_bhargav/widgets/widgets_importer.dart';

import 'contact_selection.dart';
import 'invitaion_complete_screen.dart';

int _transfeID;

List<CustomContact> contactList;

class InviteContact extends StatefulWidget {
  InviteContact(List<CustomContact> uiCustomContacts) {
    contactList = uiCustomContacts;
  }

  @override
  _InviteContactState createState() => _InviteContactState();
}

class _InviteContactState extends State<InviteContact> {
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    BeginTransfer();
  }

  @override
  Widget build(BuildContext context) {
    return SafeArea(
      child: MaterialApp(
        debugShowCheckedModeBanner: false,
        color: Colors.white,
        home: Scaffold(
          body: Container(
            color: Colors.white,
            child: Column(
              children: [
                Expanded(
                  flex: 1,
                  child: Align(
                    alignment: Alignment.bottomCenter,
                    child: InkWell(
                      onTap: () async {},
                      child: Image.asset(
                        StringUtils.IC_LOGO,
                        width: 50,
                        height: 50,
                      ),
                    ),
                  ),
                ),
                AddSizeBox(100, 0),
                Expanded(
                  flex: 1,
                  child: Container(
                    child: Text(
                      StringUtils.INVITE_CONTACT_MESSAGE,
                      textAlign: TextAlign.center,
                      style: TextStyle(
                          decoration: TextDecoration.none,
                          fontSize: 15,
                          color: Colors.black),
                    ),
                  ),
                ),
              ],
            ),
          ),
        ),
      ),
    );
  }

  Future<void> BeginTransfer() async {
    print('-------- BeginTransfer');
    var body = json.encode({
      StringUtils.TOKEN: StringUtils.getToken(),
    });
    Map<String, dynamic> map =
        await CommonUtils.apiCall(StringUtils.BEGIN_TRANSFER, body);
    if (map[StringUtils.STATUS].toString().compareTo(StringUtils.SUCCESS) !=
        null) {
      _transfeID = map[StringUtils.TRANSFER_ID];
      InviteContact();
    }
    // CommonUtils.showToast(map[StringUtils.MESSAGE], Colors.green);
  }

  Future<void> InviteContact() async {
    print('-------- InviteContact');
    var body = json.encode({
      StringUtils.TOKEN: StringUtils.getToken(),
      StringUtils.TRANSFER_ID: _transfeID,
      StringUtils.TRANSACTION_ID: '101',
      StringUtils.CONTACTS: [
        for (int i = 0; i < contactList.length; i++)
          ContactData(
                  contactList[i].contact.displayName,
                  contactList[i].contact.emails.toList().length > 0
                      ? [0].toString()
                      : '',
                  contactList[i].contact.phones.toList().length > 0
                      ? [0].toString()
                      : '')
              .toJson(),
      ],
    });
    Map<String, dynamic> map =
        await CommonUtils.apiCall(StringUtils.INVITE_CONTACT, body);
    if (map[StringUtils.STATUS].toString().compareTo(StringUtils.SUCCESS) !=
        null) {
      EndTransfer();
    }
    // CommonUtils.showToast(map[StringUtils.MESSAGE], Colors.green);
  }

  Future<void> EndTransfer() async {
    print('-------- EndTransfer');
    var body = json.encode({
      StringUtils.TOKEN: StringUtils.getToken(),
    });
    Map<String, dynamic> map =
        await CommonUtils.apiCall(StringUtils.END_TRANSFER, body);
    if (map[StringUtils.STATUS].toString().compareTo(StringUtils.SUCCESS) !=
        null) {
      Route route =
          MaterialPageRoute(builder: (context) => InvitationComplete());
      Navigator.pushReplacement(context, route);
      /*Navigator.push(
        context,
        MaterialPageRoute(builder: (context) => InvitationComplete()),
      );*/
    }
    CommonUtils.showToast(map[StringUtils.MESSAGE], Colors.green);
  }
}

class ContactData {
  String name = '', email = '', phone = '';

  ContactData(this.name, this.email, this.phone);

  Map toJson() => {
        'name': name,
        'email': email,
        'phone': phone,
      };
}
